#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "opengl-magic.h"

#define dt 0.05

float t = 0.0;
float x = -0.9;
float vx = 0.1;
float y = -0.4;
float vy = 0.05;
float ax = -0.01;

void draw (void)
{
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix ();
  glTranslatef (x, y, 0);
  glutSolidTeapot (0.05);
  glPopMatrix ();
  glFlush ();
  glutSwapBuffers ();
}

void timer_handler (int value)
{
  t += dt;
  x += vx * dt;
  y += vy * dt;
  ax = 0.1 * vx;
  vx += ax * dt;
  glutPostRedisplay ();
  glutTimerFunc (50, timer_handler, 0);
}

int main (int argc, char **argv)
{
  init_opengl (&argc, argv, "Orbit");
  glutDisplayFunc (draw);
  glutTimerFunc (50, timer_handler, 0);
  glutMainLoop ();
  return 0;
}
