#include <stdio.h>
#include <stdlib.h>

#define SIZE_X 60
#define SIZE_Y 30

#define EAST  0
#define NORTH 1
#define WEST  2
#define SOUTH 3

char world[SIZE_Y][SIZE_X + 1] = {
  "         ________________________________                   ",
  "      _-~                                ~-_                ",
  "    .~                                      ~.              ",
  "    |                                        |              ",
  "    |                                        |              ",
  "    |                                        |              ",
  "    |            .-----.                     |              ",
  "    |            |     |                     `--------.     ",
  "    |            |     |                              |     ",
  "    |            `-----'                              |     ",
  "    |                                                 |     ",
  "    |                                                 |     ",
  "    |                                                 |     ",
  "    |                              .------------------'     ",
  "    |                              |                        ",
  "    |                              `------------------.     ",
  "    |                                                 |     ",
  "    |                                                 |     ",
  "    |                                                 |     ",
  "    `------------____                                 |     ",
  "                     ~~-.                             |     ",
  "                         |                            |     ",
  "                         |                            |     ",
  "                         |                          R |     ",
  "                         |____________________________|     ",
  "                                                            ",
  "                                                            ",
  "                                                            ",
  "                                                            ",
  "                                                            " };

int rx = SIZE_X / 2, ry = SIZE_Y / 2;
int dx = 1, dy = 0;

void setup (void)
{
  for (int y = 0; y < SIZE_Y; y++)
    for (int x = 0; x < SIZE_X; x++)
      if (world[y][x] == 'R')
        {
          rx = x;
          ry = y;
          world[y][x] = ' ';
        }
}

void show_world (void)
{
  char Rsave = world[ry][rx];
  world[ry][rx] = 'R';
  for (int y = 0; y < SIZE_Y; y++)
    printf ("%s\n", world[y]);
  world[ry][rx] = Rsave;
}

void pause (void)
{
  char dummy[42];
  fgets (dummy, 42, stdin);
}

void game_over (void)
{
  printf ("GAME OVER\n");
  exit (1);
}

void check (void)
{
  if (rx < 0 || rx >= SIZE_X || ry < 0 || ry >= SIZE_Y)
    game_over ();
}

void move (int distance)
{
  rx += 2 * distance * dx;
  ry += distance * dy;
  check ();
}

void rotate_to (int direction)
{
  if (direction == EAST)
    {
      dx = 1;
      dy = 0;
    }
  else if (direction == NORTH)
    {
      dx = 0;
      dy = -1;
    }
  else if (direction == WEST)
    {
      dx = -1;
      dy = 0;
    }
  else if (direction == SOUTH)
    {
      dx = 0;
      dy = 1;
    }
  else
    game_over ();
}

int main (void)
{
  setup ();
  show_world ();
  pause ();
  while (1)
    {
      for (int i = 0; i < 3; i++)
        {
          move (1);
          show_world ();
          pause ();
        }
      rotate_to (NORTH);
      for (int i = 0; i < 3; i++)
        {
          move (1);
          show_world ();
          pause ();
        }
      rotate_to (WEST);
      for (int i = 0; i < 3; i++)
        {
          move (1);
          show_world ();
          pause ();
        }
      rotate_to (SOUTH);
      for (int i = 0; i < 3; i++)
        {
          move (1);
          show_world ();
          pause ();
        }
      rotate_to (EAST);
    }
  return 0;
}
